# -*- coding: utf-8 -*-
"""NextGpaModel.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1J-FgDYHvUzANzh3LJJH9AMk6NIgwfu-J
"""

import numpy as np
import pandas as pd
from sklearn.model_selection import train_test_split
from sklearn.metrics import confusion_matrix
from sklearn.metrics import classification_report
import joblib
import sklearn.linear_model as skl_lm
import io
from sklearn.metrics import confusion_matrix
from sklearn.metrics import plot_confusion_matrix
import matplotlib.pyplot as plt

from google.colab import files
uploaded = files.upload()
dataset = pd.read_csv(io.BytesIO(uploaded['NextGpa.csv']))

def marks(mark):
    if(mark>=17):
        return(1)
    elif(mark>=13 and mark<17):
        return(2)
    elif(mark<13):
        return(3)
dataset["TF_gpa_level"]=dataset["TF_gpa"].apply(marks)
dataset["S_gpa_level"]=dataset["S_gpa"].apply(marks)
dataset["TS_gpa_level"]=dataset["TS_gpa"].apply(marks)
dataset["Th_gpa_level"]=dataset["Th_gpa"].apply(marks)

X=dataset[['gender', 'residence', 'entering_type','entering',
       'F_obtained_units', 'TF_gpa_level',
       'S_obtained_units', 'S_gpa_level', 'TS_gpa_level',
       'Th_obtained_units',
       'obtained_units_till_Th', 'f_o', 'p_o', 'terms_last', 'm_t']]
Y=dataset['Th_gpa_level']

x_train, x_test, y_train, y_test = train_test_split(X, Y, test_size = 0.2, random_state = 0, shuffle = True)

from sklearn.svm import SVC
svclassifier = SVC(kernel='linear')
svclassifier.fit(x_train, y_train)
y_pred = svclassifier.predict(x_test)
cm = confusion_matrix(y_test,y_pred)
print(classification_report(y_test,y_pred))
fig, ax = plt.subplots(figsize=(8, 8))
plot_confusion_matrix(svclassifier, x_test, y_test, normalize='true', cmap=plt.cm.Blues, ax=ax)
plt.show()
df3 = pd.DataFrame({'Actual': y_test, 'Predicted': y_pred})
print(df3)

joblib.dump(svclassifier, 'NextGpaClassifier.joblib')

